// +=============================================+
// |  ____  _            _     ____ _ _          |
// | | __ )| | ___   ___| | __/ ___(_) |_ _   _  |
// | |  _ \| |/ _ \ / __| |/ / |   | | __| | | | |
// | | |_) | | (_) | (__|   <| |___| | |_| |_| | |
// | |____/|_|\___/ \___|_|\_\\____|_|\__|\__, | |
// |                                      |___/  |
// +=============================================+
// | This file contains datablocks for the script|
// | You can edit some settings here.		 |
// +---------------------------------------------+

datablock DecalData(BlocklandCityLogo)
{
   textureName = "Add-Ons/Script_BlockCity/ssblocklandcity.png";
};

// +==============+
// | RESOURCE MOD |
// +==============+
//
// MDRM_BPH is the "Blocks Per Hit"
//  - Modify it to change resources reward, cost, respawn time
// MDRM_TotalHits is the hits required to gather this item
//  - Changing this directly affects reward, cost, respawn time
// MDRM_Color is of course the color of the block when spawned
//  - in RGBA Decimal Format
//
// THE FOLLOWING MATHEMATICAL FORMULAS ARE USED TO FIND VALUES FOR RESOURCES
//
// %Cost	= MDRM_BPH * MDRM_TOTALHITS * $PREF::MDRM::COSTMULTIPLIER
// %Reward	= MDRM_BPH * MDRM_TOTALHITS
// %RespawnTime	= MDRM_BPH * MDRM_TOTALHITS * $PREF::MDRM::RESPAWNMULTIPLIER
// %Refund	= MDRM_BPH * MDRM_TOTALHITS * $PREF::MDRM::COSTMULTIPLIER / 2
//
// 
// +-------+
// | TREES |
// +-------+
datablock fxDTSBrickData (brickPineWoodData)     
{     
	brickFile = "base/data/bricks/special/pineTree.blb";
	iconName = "base/client/ui/brickIcons/Pine Tree.png";
	collisionShapeName = "base/data/shapes/bricks/pinetree.dts";
	category = "Resources";
	subCategory = "Trees";
	uiName = "Pine";
	isMDRMResource = true;
	MDRM_Projectile = "AxeProjectile";
	MDRM_Cat = " Tree";
	MDRM_BPH = 0.21; // Blocks Per Hit
	MDRM_TotalHits = 20;
	MDRM_Color = "0 .5 .25 1";
};
//Inherit everything from "brickPineWoodData"
//Redefine just what we need      
datablock fxDTSBrickData (brickBirchWoodData : brickPineWoodData)     
{
	uiName = "Birch";
	MDRM_TotalHits = 40;
	MDRM_Color = "1 1 1 1";
};
datablock fxDTSBrickData (brickDeadWoodData : brickPineWoodData)     
{
	uiName = "Dead";
	MDRM_TotalHits = 10;
	MDRM_Color = "0.5 0.2 0.2 1";
};
// +------+
// | ORES |
// +------+
datablock fxDTSBrickData (brickCopperOreData)     
{     
	brickFile = "base/data/bricks/bricks/2x2.blb";
	iconName = "base/client/ui/brickIcons/2x2.png";
	category = "Resources";
	subCategory = "Ores";
	uiName = "Copper";
	isMDRMResource = true;
	MDRM_Projectile = "DiggerProjectile";
	MDRM_Cat = " Ore";
	MDRM_BPH = 0.21; // Blocks Per Hit
	MDRM_TotalHits = 30;
	MDRM_Color = "1 0.45 0.2 1";
};    
datablock fxDTSBrickData (brickIronOreData : brickCopperOreData)     
{
	uiName = "Iron";
	MDRM_TotalHits = 50;
	MDRM_Color = "0.5 0.5 0.5 1";
};
datablock fxDTSBrickData (brickSilverOreData : brickCopperOreData)     
{
	uiName = "Silver";
	MDRM_TotalHits = 65;
	MDRM_Color = "0.9 0.9 0.9 1";
};
datablock fxDTSBrickData (brickGoldOreData : brickCopperOreData)     
{
	uiName = "Gold";
	MDRM_TotalHits = 75;
	MDRM_BPH = 0.22;
	MDRM_Color = "0.9 0.9 0 1";
};
datablock fxDTSBrickData (brickDirtOreData : brickCopperOreData)     
{
	uiName = "Dirt";
	MDRM_Cat = "";
	MDRM_TotalHits = 10;
	MDRM_Color = "0.5 0.2 0.2 1";
	MDRM_RespawnMultiplier = 2.5;
};
datablock fxDTSBrickData (brickPyriteOreData : brickCopperOreData)     
{
	uiName = "Pyrite";
	MDRM_TotalHits = 45;
	MDRM_Color = "0.8 0.8 0 1";
};
datablock fxDTSBrickData (brickTinOreData : brickCopperOreData)     
{
	uiName = "Tin";
	MDRM_TotalHits = 15;
	MDRM_Color = "0.6 0.6 0.6 1";
};
// +------+
// | GEMS |
// +------+
datablock fxDTSBrickData (brickSapphireGemData)     
{     
	brickFile = "Add-Ons/Script_BlockCity/4x Cube.blb";
	iconName = "add-ons/brickIcons/Mine";
	category = "Resources";
	subCategory = "Gems";
	uiName = "Sapphire";
	isMDRMResource = true;
	MDRM_Projectile = "DiggerProjectile";
	MDRM_Cat = " (Gem)";
	MDRM_BPH = 0.23; // Blocks Per Hit
	MDRM_TotalHits = 100;
	MDRM_Color = "0 0 1 0.7";
};    
datablock fxDTSBrickData (brickEmeraldGemData : brickSapphireGemData)     
{
	uiName = "Emerald";
	MDRM_TotalHits = 120;
	MDRM_Color = "0 1 0 0.7";
};
datablock fxDTSBrickData (brickRubyGemData : brickSapphireGemData)     
{
	uiName = "Ruby";
	MDRM_TotalHits = 150;
	MDRM_Color = "1 0 0 0.7";
};
datablock fxDTSBrickData (brickDiamondGemData : brickSapphireGemData)     
{
	uiName = "Diamond";
	MDRM_BPH = 0.25;
	MDRM_TotalHits = 400; // The hardest mineral on earth, so it should take a while.
	MDRM_Color = "1 1 1 0.7";
};
datablock fxDTSBrickData (brickOpalGemData : brickSapphireGemData)     
{
	uiName = "Opal"; // OOOOOOOoooooOOoooooOoOOOOoo Shiny....
	MDRM_TotalHits = 75;
	MDRM_Color = "0 1 .3 0.7";
};
datablock fxDTSBrickData (brickQuartzCrystalData : brickSapphireGemData)     
{
	uiName = "Quartz"; // Quartz, a hard cheap common crystal (mine filler)
	MDRM_Cat = " (Crystal)";
	MDRM_BPH = 0.21;
	MDRM_TotalHits = 25;
	MDRM_Color = "1 1 1 0.8";
};
datablock fxDTSBrickData (brickAmethystGemData : brickSapphireGemData)     
{
	uiName = "Amethyst"; // The Violet form of quartz, beautiful so used as a gemstone.
	MDRM_TotalHits = 60;
	MDRM_Color = "1 0 1 0.7";
};