//    _____            __    __ __    __   
//   / __(_)_ _  ___  / /__ / // /__ / /__ 
//  _\ \/ /  ' \/ _ \/ / -_) _  / -_) / _ \
// /___/_/_/_/_/ .__/_/\__/_//_/\__/_/ .__/
// -----------/_/- Beta Version ----/_/---
// 	By Mr. Doom
//
// +===============================+
// | Mr. Doom's Simple Help System |
// +===============================+
//
// +===========================================================+
// | VERSION	: 6					       |
// | REVISION	: B					       |
// | RELEASE	: Beta					       |
// +-----------------------------------------------------------+
// | 			     === EULA ===		       |
// | 	By use of this script you agree to the following EULA  |
// |							       |
// | This script may be distributed with Scattered Space RPGs  |
// | It is free for modification and distribution by SS Clan   |
// | So long as both this notice and SDB Logos stay intact.    |
// | Additionaly any distribution must contain credit to       |
// | Mr. Doom, Modification of this EULA is punishable by law  |
// +-----------------------------------------------------------+
// | All other rights reserved by author.		       |
// +===========================================================+
//
// Original Version based off Jookia's "Hellen" Help System
//
$SimpleHelp::Debug = 0;
$SimpleHelp::AutoLoad = 1;
//-- DO NOT EDIT BELOW THIS LINE --//
$SimpleHelp = "0.6B";
function SimpleHelp::onAdd(%this)
{
	if(%this.getName() $= "")
	{
		error("SimpleHelp::onAdd(): You must specifiy a name for SimpleHelp! Aborting...");
		%this.schedule(0, "delete");
		return false;
	}
	if(%this.helpFile $= "")
	{
		warn(%this.getName()@"::onAdd(): Help File not specified, searching defaults.");
		if(!isFile("config/Server/"@%this.getName()@".XHLP"))
		{
			error(%this.getName()@"::onAdd(): Could not find any help file or any default help file! Aborting...");
			%this.schedule(0, "delete");
			return false;
		}
	}
	else
	{
		if($SimpleHelp::Debug) warn(%this.getName()@"::onAdd(): SaveFile Specified, Testing it...");
		if(!isFile(%this.helpFile))
		{
			error(%this.getName()@"::onAdd(): SaveFile Specified but nonexistent! Aborting...");
			%this.schedule(0, "delete");
			return false;
		}
		else
		{
			if($SimpleHelp::Debug) warn(%this.getName()@"::onAdd(): SaveFile Found!");
			if($SimpleHelp::AutoLoad)
			{
				if($SimpleHelp::Debug) warn(%this.getName()@"::onAdd(): Begginning AutoLoad!");
				%this.loadHelp(%this.helpFile);
			} else if($SimpleHelp::Debug) warn(%this.getName()@"::onAdd(): Autoload disabled... Help File Will not load!");
		}
	}
	return true;
}

function SimpleHelp::onRemove(%this)
{
	//NULL
}
function SimpleHelp::ParseSection(%this,%sectag,%section)
{
	if(StrPos(%section,"<"@%sectag) < 0)
	{
		error(%this.getName()@"::ParseSection(): Could not find tag \""@%sectag@"\" in data! Aborting...");
		return false;
	}
	if(StrPos(%section,"</"@%sectag@">") < 0)
	{
		error(%this.getName()@"::ParseSection(): Could not find closing tag \"</"@%sectag@">\" in data! Aborting...");
		return false;
	}
	//
	// Processing Sector
	//
	%secStartTag = "<"@%sectag;
	%secCloseTag = "</"@%sectag@">";

	// It looks messy but it does it's job quickly and efficiently.	

	%RawSectionData = getSubStr(%section,strPos(%section,%secStartTag),strPos(%section,%secCloseTag)+strLen(%secCloseTag));
		if($SimpleHelp::Debug) warn("RAW SECTION DATA:"@%RawSectionData);
	%SectionTag = getSubStr(%RawSectionData,strPos(%RawSectionData,%secStartTag),strPos(%RawSectionData,">")+1);
		if($SimpleHelp::Debug) warn("RAW SECTION TAG:"@%SectionTag);
	%SectionName = getSubStr(%SectionTag,strPos(%SectionTag,"NAME=\""),strLen(%SectionTag));
		if($SimpleHelp::Debug) warn("RAW SECTION NAME:"@%SectionName);
	%SectionName = strReplace(strReplace(%SectionName,"\\\"","&DBQUOTE"),"NAME=\"","");
		if($SimpleHelp::Debug) warn("SEMI DONE SECTION NAME:"@%SectionName);
	%SectionName = strReplace(getSubStr(%SectionName,0,strPos(%SectionName,"\"")),"&DBQUOTE","\"");
		if($SimpleHelp::Debug) warn("COMPLETE SECTION NAME:"@%SectionName);
	%SectionData = strReplace(getSubStr(%RawSectionData,strLen(%SectionTag),strLen(%RawSectionData)),%secCloseTag,"");
		if($SimpleHelp::Debug) warn("PROCESSED SECTION DATA:"@%SectionData);
	
	// This first one removes any extra preceeding or trailing newlines, (so you can have cleaner tabbed/spaced/newlined code in the .XHLP file)
	%ReturnData = setRecord(%ReturnData,0,strReplace(trim(strReplace(%sectionData,"&NEWLINE","\n")),"\n","&NEWLINE"));
	%ReturnData = setRecord(%ReturnData,1,%SectionName);
	%ReturnData = setRecord(%ReturnData,2,%SectionTag);
	%ReturnData = setRecord(%ReturnData,3,%RawSectionData);
	return %returnData;
}
function SimpleHelp::loadHelp(%this,%helpfile)
{
	if(!isFile(%helpfile))
	{
		error(%this.getName()@"::LoadHelp(): Help File does not exist! Aborting...");
		return false;
	}
	if(fileExt(%helpfile) !$= ".XHLP")
		if($SimpleHelp::Debug) warn(%this.getName()@"::LoadHelp(): Savefile extension is not XHLP ("@fileExt(%helpfile)@"), Savefile might not be supported!");
	
	%file = new fileObject();
	%file.openForRead(%helpfile);

	%this.sections = "";
	
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		

		//Remove Comments even Multilines
		if(strpos(%line,"<!--") >= 0)
		{
			for(%i=0;strPos(%line,"-->") < 0;%i++)
			{
				if(%i > 25) { error("25+ LINE COMMENT, Abort... Something is wrong!"); return false; }		
				%line = %line SPC "&NEWLINE" SPC trim(%file.readLine());
			}
			%line = getSubStr(%line,0,strpos(%line,"<!--")) @ getSubStr(%line,strpos(%line,"-->")+3,strLen(%line));
		}
		if(strPos(%line,"<SECTION") >= 0)
		{
			for(%i=0;strPos(%line,"</SECTION>") < 0;%i++)
			{
				if(%i > 25) { warn("25+ LINES, BREAK!"); break; }		
				%line = %line SPC "&NEWLINE" SPC trim(%file.readLine());
			}
			%parsedData = %this.ParseSection("SECTION",%line);
			%SectionName = getRecord(%parsedData,1);
			%SectionData = getRecord(%parsedData,0);
			
			if(strlwr(%sectionName) $= "") continue;


			for(%i=0;strPos(%SectionData,"<SUBSECTION")>=0;%i++)
			{
				if(%i> 10) break;
				%SubParsedData = %this.ParseSection("SUBSECTION",%SectionData);
				%SubSectionName = getRecord(%SubParsedData,1);
				%SubSectionData = getRecord(%SubParsedData,0);
				%SubSectionRawData = getRecord(%SubParsedData,3);

				%SectionData = strReplace(%SectionData,%SubSectionRawData,"");
				if($SimpleHelp::Debug) warn("CLEANING-ED SECTION DATA:"@%sectionData);
				
				%this.section[strlwr(%sectionName)] = "SUB";
				%this.section[strlwr(%sectionName),"Subs"] = trim(%this.section[strlwr(%SectionName),"Subs"] SPC strlwr(%SubSectionName));
				%this.section[strlwr(%sectionName),strLwr(%SubSectionName)] = %SubSectionData SPC "&NEWLINE";
			}
			%this.sections = trim(%this.sections SPC %sectionName);
			if(%this.section[strlwr(%sectionName)] !$= "SUB")
				%this.section[strlwr(%sectionName)] = strReplace(trim(strReplace(%sectionData,"&NEWLINE","\n")),"\n","&NEWLINE") SPC "&NEWLINE";
			else
				%this.section[strlwr(%sectionName),"default"] = strReplace(trim(strReplace(%sectionData,"&NEWLINE","\n")),"\n","&NEWLINE") SPC "&NEWLINE";
		}
	}
	if(getWordCount(%this.sections) < 0)
		warn(%this.getName()@"::LoadHelp(): No sections found! Aborting...");
	
	%file.close();
	%file.delete();
	
	return true;
}
function SimpleHelp::displaySections(%this,%client)
{
	//messageClient(%client,'',"\c3 SimpleHelp v\c0"@$SimpleHelp@"\c3 By Mr. Doom");
	messageClient(%client,'',"\c3 === "@%this.helpTitle@" Help ===");
	messageClient(%client,'',"\c6 The following are section names, use /help sectionName for them");
	for(%i=0;%i<getWordCount(%this.sections);%i++)
	{
		%dc++;
		%data = trim(%data SPC "|" SPC getWord(%this.sections,%i));
		if(%dc >= 4)
		{
			messageClient(%client,'',"\c7"@%data);
			%data = "";
			%dc=0;
		}
	}
	if(%data !$= "") messageClient(%client,'',"\c7"@%data);
}
function SimpleHelp::displayHelp(%this, %client, %section)
{
	if(strPos(%section,"_")) %sectionname = getWord(strReplace(%section,"_"," "),0);
	else %sectionname = %section;
	if(%section $= "")
	{
		%this.displaySections(%client);
		return true;
	}
	if(striPos(" "@%this.sections@" "," "@%sectionname@" ") < 0)
	{
		messageClient(%client,"","\c3SimpleHelp\c6 : Section \""@%sectionname@"\" does not exist.");
		warn(%this.getName()@"::displayHelp(): Section not found! Aborting...");
		return false;
	}
	%data = %this.section[strlwr(%section)];

	if(strPos(%section,"_"))
		messageClient(%client,'',"\c7 ========== "@strUpr(%sectionName)@"->"@getWord(strReplace(%section,"_"," "),1)@"");
	else
		messageClient(%client,'',"\c7 ========== "@strUpr(%sectionName));
	if(%data $= "SUB")
	{
		%data = "";
		messageClient(%client,'',"\c6 The following are subsection names, use /help "@%section@"_subName for them");
		for(%i=0;%i<getWordCount(%this.section[strlwr(%section),"Subs"]);%i++)
		{
			%dc++;
			%data = trim(%data SPC getWord(%this.section[strlwr(%section),"Subs"],%i));
			if(%dc >= 4)
			{
				messageClient(%client,'',"\c7"@%data);
				%data = "";
				%dc=0;
			}
		}
		if(%data !$= "") messageClient(%client,'',"\c7"@%data);
		%data = %this.section[strlwr(%section),"default"];
	}	
	for(%i=0;%i<20;%i++)
	{
		if(strPos(%data,"&NEWLINE")<0)
			break;
		%subdata = getSubStr(%data,0,strPos(%data,"&NEWLINE")+8);
		%data = strReplace(%data,%subdata,"");
		%subdata = strReplace(%subdata,"&NEWLINE","");
		if($SimpleHelp::Debug) warn("SUBDATA:"@%subdata);
		if($SimpleHelp::Debug) warn("DATA:"@%data);
		eval("messageClient("@%client@",'',\""@%subdata@"\");");
	}
	//eval("messageClient("@%client@",'',\""@%this.section[strlwr(%section)]@"\");");
	return true;
}