// +============================+
// | Mr. Doom's Spawning System	|
// +============================+
//
// +===========================================================+
// | VERSION	: 4					       |
// | REVISION	: 0					       |
// | RELEASE	: Alpha					       |
// +===========================================================+


//-- OPTIONS --//
$SimpleSpawn::AdminOnly = 1; //(exceptPersonalSpawns)
$SimpleSpawn::Personals = 0; // Allow Personals
//-- END OPTIONS--//
//-- Spawner Example --//
datablock fxDTSbrickData(brickDMSpawnPointData : brickSpawnPointData)
{
	uiName = "Deathmatch Spawn Point";
	simpleSpawn = true;
	simpleSpawnCat = "BlockCityDM";
	specialBrickType = "";
};
//datablock fxDTSbrickData(brickPersonalSpawnPointData : brickSpawnPointData)
//{
//	uiName = "Personal Spawn Point";
//	simpleSpawn = true;
//	simpleSpawnCat = "PERSONAL";
//	specialBrickType = "";
//};
//-- End Spawner Example --//

//-- DO NOT EDIT BELOW THIS LINE --//


// I'm not sure what the package "MiniPlayerSpawn" is but
// it causes serious problems
if(isPackage(MiniPlayerSpawn)) deactivatePackage(MiniPlayerSpawn);
package SimpleSpawn
{
	function GameConnection::SpawnPlayer(%client)
	{
		%client.spawning = true;
		Parent::SpawnPlayer(%client);
	}

	// AntiChargePlayer hotfix (now it just denies them earlier)
	function serverCmdPlantBrick(%client)
	{
		%brick = %client.Player.tempBrick;  // This is the ghost brick, but it has the same datablock so it works.
		if(!isObject(%brick)) return;
		if(!%client.isAdmin && $SimpleSpawn::AdminOnly && (%brick.getDatablock().simpleSpawn || %brick.getDatablock().specialBrickType $= "SpawnPoint"))
		{
			messageClient(%client,"centerPrint","\c6Only admins are allowed to plant global spawn bricks!",3);
			return false;
		}
		parent::serverCmdPlantBrick(%client);
	}

	function FxDTSBrick::onPlant(%brick)
	{

		%client = %brick.getGroup().client;
		if(%brick.getDatablock().simpleSpawn)
		{
			if(%brick.getDatablock().simpleSpawnCat $= "PERSONAL")
			{
				if(!$SimpleSpawn::Personals)
				{
					messageClient(%client,"centerPrint","\c6Personal Spawns Disabled",3);
					%brick.schedule(0,"delete");
					return;
				}
				if(isObject($SimpleSpawnPersonal[%client.BL_ID]))
				{
					messageClient(%client,"centerPrint","\c6You may only have one personal spawn!",3);
					%brick.schedule(0,"delete");
					return;
				}
				$SimpleSpawnPersonal[%client.BL_ID] = %brick;
			}
			else
			{
				if(!%client.isAdmin && $SimpleSpawn::AdminOnly)
				{
					messageClient(%client,"centerPrint","\c6Only admins are allowed to plant global spawn bricks!",3);
					%brick.schedule(0,"delete");
					return;
				}
				if(strPos($SimpleSpawn[%brick.getDatablock().simpleSpawnCat],%brick) >= 0)
				{
					return;
				}
				$SimpleSpawn[%brick.getDatablock().simpleSpawnCat] = trim($SimpleSpawn[%brick.getDatablock().simpleSpawnCat] SPC %brick);
			}
		}
		else if(%brick.getDatablock().specialBrickType $= "SpawnPoint")
		{
			if(strPos($SimpleSpawnStandard,%brick) >= 0)
			{
				return;
			}
			$SimpleSpawnStandard = trim($SimpleSpawnStandard SPC %brick);
		}
		parent::onPlant(%brick);
	}
	function fxDTSBrick::onDeath(%brick)
	{
		if(%brick.getDatablock().simpleSpawn)
			SimpleSpawn_RemoveSpawn(%brick);
		Parent::onDeath(%brick);
	}

	function MinigameSO::pickSpawnPoint(%this,%client)
	{
		if(%this.useSimpleSpawn)
		{
			if(%this.usePersonalSpawns && isObject($SimpleSpawnPersonal[%client.BL_ID]))
			{
				%spawnBrick = $SimpleSpawnPersonal[%client.BL_ID];
			}
			if(!isObject(%spawnBrick))
			{
				if(%this.simpleSpawnCat $= "")
				{
					error("SimpleSpawn: CATEGORY NOT SPECIFIED FOR MINIGAME! (Defaulting)");
					return pickSpawnPoint();
				}
				for(%i=0;%i<getWordCount($SimpleSpawn[%this.simpleSpawnCat]);%i++)
				{
					%SpawnPoint = getWord($SimpleSpawn[%this.simpleSpawnCat],getRandom(0,getWordCount($SimpleSpawn[%this.simpleSpawnCat])-1));
					if(isObject(%spawnPoint))
						break;
				}
			}
		}
		if(!isObject(%spawnPoint))
		{
			for(%i=0;%i<getWordCount($SimpleSpawnStandard);%i++)
			{
				%SpawnPoint = getWord($SimpleSpawnStandard,getRandom(0,getWordCount($SimpleSpawnStandard)-1));
				if(isObject(%spawnPoint))
					break;
			}
			if(!isObject(%spawnPoint))
			{
				return pickSpawnPoint();
			}
		}
		//Thank you spaceguy
		%trans = %SpawnPoint.getTransform();
		%pos = posFromTransform(%trans);
		%rot = rotFromTransform(%trans);
		if(fileName(%spawnPoint.getdataBlock().brickfile) $= "spawnPoint.blb")
			%pos = vectorSub(%pos,"0 0 1.25");
		else
			%pos = vectorAdd(%pos,"0 0 " @ %spawnPoint.getdataBlock().brickSizeZ*0.1);
		return %pos SPC %rot;
	}

};
activatePackage(SimpleSpawn);

// Modified from SDB v3
function SimpleSpawn_FindSpawnIndex(%spawn)
{
	// Checks Sector -- Test Input
	if(%spawn $= "" || !isObject(%spawn))
	{
		echo("SimpleSpawn_FindSpawnIndex() Spawn Argument Not Specified/Non-Object! Aborting...");
		return -1;
	}
	if(!%spawn.getDatablock().simpleSpawn)
	{
		error("SimpleSpawn_FindSpawnIndex() specified value not a SimpleSpawn! Aborting...");
		return -1;
	}

	// Main Sector -- Find The Spawn and return Index
	for(%i = 0; getWordCount($SimpleSpawn[%spawn.getDatablock().simpleSpawnCat]) > %i; %i++)
	{
		if(getWord($SimpleSpawn[%spawn.getDatablock().simpleSpawnCat], %i) $= %spawn)
			return %i;
	}
	return -1;
}
function SimpleSpawn_RemoveSpawn(%spawn)
{
	// Checks Sector -- Test Input
	if(%spawn $= "" || !isObject(%spawn))
	{
		echo("SimpleSpawn_RemoveSpawn() Spawn Argument Not Specified/Non-Object! Aborting...");
		return -1;
	}
	if(!%spawn.getDatablock().simpleSpawn)
	{
		error("SimpleSpawn_RemoveSpawn() specified value not a SimpleSpawn! Aborting...");
		return -1;
	}
	if(%spawn.getDatablock().simpleSpawnCat $= "PERSONAL")
	{
		$SimpleSpawnPersonal[%brick.getGroup().BL_ID] = "";
		return true;
	}
	%spawnindex = SimpleSpawn_FindSpawnIndex(%spawn);
	if(%spawnindex < 0)
	{
		echo("SimpleSpawn_RemoveSpawn() Spawn does not exist in spawnlist! Aborting...");
		return false;
	}

	// Main Sector -- Remove The Spawn From Index

	// This is done the "clean" way, with a loop to actually
	// Remove the data.
	$SimpleSpawn[%spawn.getDatablock().simpleSpawnCat] = trim(removeWord($SimpleSpawn[%spawn.getDatablock().simpleSpawnCat], %spawnindex));
	return true;
}