// +=============================================+
// |  ____  _            _     ____ _ _          |
// | | __ )| | ___   ___| | __/ ___(_) |_ _   _  |
// | |  _ \| |/ _ \ / __| |/ / |   | | __| | | | |
// | | |_) | | (_) | (__|   <| |___| | |_| |_| | |
// | |____/|_|\___/ \___|_|\_\\____|_|\__|\__, | |
// |                                      |___/  |
// +=============================================+
// | This is the "BASE" of the entire script.	 |
// | The major features are handled here.	 |
// | It is responsible for the initialization of |
// | everything for block city.			 |
// | Do not modify this file.			 |
// +---------------------------------------------+
//
//
//
// +----------------------------------------------+
// | Initialize the logging system (if it exists) |
// +----------------------------------------------+
if(!isfile("config/log.cs"))
{
	$BClog[total] = 0;
}
// +---------------------+
// | Initialize SimpleDB |
// +---------------------+
if(!isObject(BCDB))
{
	new scriptObject(BCDB)
	{
		class = SimpleDB;
		autoLoad = 1;
		autoSave = 1;
		saveFile = "config/server/Block_City.db";
	};
	if(!BCDB.hasLoaded)
	{
		BCDB.addField("BLOCKS",$Pref::blockCity::newUserBlockAmount); // field, defaultvalue
		BCDB.addField("VIP","false");
	}
	BCDB.saveTick(10); //Time in minutes specified here
}
// +-----------------------+
// | Initialize SimpleHelp |
// +-----------------------+
if(!isObject(BCHLP))
{
	new scriptObject(BCHLP)
	{
		class = SimpleHelp;
		autoLoad = 1;
		helpFile = "Add-Ons/Script_BlockCity/BlockCity.XHLP";
		helpTitle = "BlockCity 3";
	};
}

// +------------------------------------------+
// |             SimpleHelp Hook	      |
// +------------------------------------------+
// | SimpleHelp is designed for many uses,    |
// | so each script must specify a hook to it |
// +------------------------------------------+
function ServerCmdHelp(%client,%section,%a)
{
	if(%a !$= "") %section = %section@"_"@%a;
	BCHLP.displayHelp(%client,%section);
}
function CheckDediMini()
{
	//This starts the minigame.
	// +=====================================================+
	// | THESE SETTINGS WILL BE USED IF YOU DO NOT HAVE RTB! |
	// +=====================================================+
	if(!isObject($DediMini)) 
	{
		$DediMini = new ScriptObject() 
		{
			brickDamage= 0;
			brickRespawnTime= 10000;
			class=miniGameSO;
			colorIdx= 0;
			EnableBuilding= 1;
			EnablePainting= 1;
			enableWand= 1;
			fallingDamage= 1;
			inviteOnly= 0;
			numMembers=1;
			//IF YOU WANT TO CHANGE THE PLAYER-TYPE, CHANGE IT BELOW
			playerDataBlock= PlayerStandardArmor;
			PlayersUseOwnBricks= 0;
			Points_BreakBrick= 0;
			Points_Die= 0;
			Points_KillPlayer= 1;
			Points_KillSelf= 0;
			Points_PlantBrick= 0;
			respawnTime= 1000;
			SelfDamage=1;
			StartEquip0=71;
			StartEquip1=81;
			StartEquip2=393;
			StartEquip3= nametoid(DiggerItem);
			StartEquip4= nametoid(AxeItem);

			title = "BlockCity";
			useSimpleSpawn = 1;
			usePersonalSpawns = 1;
			simpleSpawnCat = "Standard";
			useAllPlayersBricks= 1;
			useSpawnBricks= 0;
			VehicleDamage= 1;
			vehicleReSpawnTime= 120000;
			weaponDamage= 0;
		};
	}
	if(!isObject($DMMini)) 
	{
		$DMMini = new ScriptObject() 
		{
			brickDamage= 0;
			brickRespawnTime= 10000;
			class=miniGameSO;
			colorIdx= 1;
			EnableBuilding= 0;
			EnablePainting= 0;
			enableWand= 0;
			fallingDamage= 1;
			inviteOnly= 0;
			numMembers=1;
			//IF YOU WANT TO CHANGE THE PLAYER-TYPE, CHANGE IT BELOW
			playerDataBlock= PlayerNoJet;
			PlayersUseOwnBricks= 0;
			Points_BreakBrick= 0;
			Points_Die= 0;
			Points_KillPlayer= 1;
			Points_KillSelf= 0;
			Points_PlantBrick= 0;
			respawnTime= 1000;
			SelfDamage=1;
			StartEquip0= nametoid(BowItem);
			StartEquip1= nametoid(SwordItem);
			StartEquip2= nametoid(spearItem);
			StartEquip3= 0;
			StartEquip4= 0;

			title = "BlockCity Deathmatch";
			useSimpleSpawn = 1;
			usePersonalSpawns = 0;
			simpleSpawnCat = "BlockCityDM";
			useAllPlayersBricks= 1;
			useSpawnBricks= 0;
			VehicleDamage= 0;
			vehicleReSpawnTime= 0;
			weaponDamage= 1;
		};
	}

}

// +---------------------------+
// | This starts the minigame. |
// +---------------------------+
if(!$Temp::ServerAutoMinigameRanOnce)
{
	$Temp::ServerAutoMinigameRanOnce = true;
	CheckDediMini();
}

// +------------------------------+
// | Runs tests on planted bricks |
// +------------------------------+
function plantBrickCheck(%brick, %client)
{
	%baseCheck = SuperBaseCheck(%brick,%client);
	%brickCheck = brickCheck(%brick,%client);
	if(%baseCheck && %brickCheck)
		return true;
	else
		return false;
}
// +-------------------------+
// | Pre-Plant brick testing |
// +-------------------------+
function BrickTest(%brick)
{
	if(!isObject(%brick)) return false;
	%client = %Brick.getGroup().client;
	%db = %brick.getDatablock();

	// +---------------------------------------------+
	// | If the Brick is a special or regular brick. |
	// +---------------------------------------------+
	if(%db.isMDRMResource && !%client.isAdmin)
	{
		%name = (%db.MDRM_Cat != "") ? %db.uiName SPC %db.MDRM_Cat : %db.uiName;
		if(BCDB.data[%client.BL_ID,"BLOCKS"] < mFloor(%db.MDRM_BPH*%db.MDRM_TotalHits*$PREF::MDRM::COSTMULTIPLIER))
		{
			commandToClient(%client, 'centerPrint', "\c6You need\c1" SPC mFloor(%db.MDRM_BPH*%db.MDRM_TotalHits*$PREF::MDRM::COSTMULTIPLIER) SPC "\c6Blocks for a "@%name@", go mine or chop trees!",3);
			return false;
		}
	} else if(!%brick.isBaseplate && !%client.isAdmin)
	{
		if(BCDB.data[%client.BL_ID,"BLOCKS"] < 1)
		{
			commandToClient(%client, 'centerPrint', "\c6You need \c01\c6 Blocks for this brick, go mine or chop trees!",3);
			return false;
		}
	}
	return true;
}
// +---------------------------------------------------------------------------------+
// | Provides Verification if brick should be planted, and tells client any problems |
// +---------------------------------------------------------------------------------+
function SuperBaseCheck(%brick, %client)
{
	if(!isObject(%brick)) return false;

	if(%brick.isBaseplate)
	{
		switch$(%brick.getDataBlock().getName())
		{
			case "brick16x16fData":
				%Cost = $Pref::blockCity::16x16BaseplateCost;
				%Name = "16x16 Baseplate";
			case "brick16x32fData":
				%client.centerprint("<just:center><color:FFBBBB>Sorry, this Baseplate cannot be planted on the ground! Please choose another Baseplate!",4);
				return false;
			case "brick32x32fData":
				%Cost = $Pref::blockCity::32x32BaseplateCost;
				%Name = "32x32 Baseplate";
			case "brick48x48fData":
				%Cost = $Pref::blockCity::48x48BaseplateCost;
				%Name = "48x48 Baseplate";
			case "brick64x64fData":
				%Cost = $Pref::blockCity::64x64BaseplateCost;
				%Name = "64x64 Baseplate";
			default:
				%client.centerprint("<just:center><color:FFBBBB>you must plant a Baseplate first before being able to build!!",4);
				return false;
		}
		if($Pref::blockCity::enableAlignment && %brick.getSurroundingBaseplateCount() < 2)
		{	
			messageClient(%client, 'MsgPlantError_Unstable');
			%client.centerprint("<just:center><color:FFBBBB>Please align your Baseplate with the road on the ground!" NL "(Plant it in a corner)",4);
			return false;
		}
		return ChargePlayer(%client,%cost,%name);
	}
	return true;
}
// +--------------------------------------------------------+
// | Tells the client, and purchases a brick (or denies it) |
// +--------------------------------------------------------+
function brickCheck(%brick, %client)
{
	//If %brick is not an object, end execution
	if(!isObject(%brick)) return false;
	%db = %brick.getDatablock();

	// +=+=+ Resource Brick Handling +=+=+

	if(%db.isMDRMResource && !%client.isAdmin)
	{
		%name = (%db.MDRM_Cat != "") ? %db.uiName SPC %db.MDRM_Cat : %db.uiName;
		return ChargePlayer(%client,mFloor(%db.MDRM_BPH*%db.MDRM_TotalHits*$PREF::MDRM::COSTMULTIPLIER),%name,0);
	} else if(!%brick.isBaseplate && !%client.isAdmin)
		return ChargePlayer(%client,1,"brick",1);
	return true;
}
// +------------------------------------------------------------------+
// | This checks to see if the player is in the server at the moment. |
// +------------------------------------------------------------------+
// DEPRECIATED (BlockCity 3-C)
function isOnline(%blid)
{
	return isObject(findClientByBL_ID(%blid)); //Since no client can be 0, if you receive 0 the client is not online.
}
// +--------------------------------------------------------------------------+
// | This makes sure that the client isn't screwing up Block giving Commands. |
// +--------------------------------------------------------------------------+
function currencyCheck(%amnt)
{
	if(!isInt(%amnt) || %amnt <= 0)
		return false;
	return true;
}
function ServerCmdDM(%client)
{
	if($DMMini.isMember(%client))
	{
		%client.recentlyJoined = schedule(30000, 0, "clearrecentlyJoined");

		$DMMini.removeMember(%client);
		if(isobject(%client.player)) %client.player.kill();
		$DediMini.addMember(%client);
	
		if(isFile("Add-Ons/Event_Variables/server.cs"))
		{
			%client.blockVCE[%client.BL_ID] = %client.oldBlockVCE[%client.BL_ID];
			%client.oldBlockVCE[%client.BL_ID] = "";
		}

		messageAll("","\c6" @ %client.netName SPC "\c4" @ "has left the DM Arena!");
		return;
	}
	if(!$Pref::blockCity::enableDM)
	{
		messageClient(%Client, "","Sorry, you cannot Deathmatch at this time!");
		return;
	}
	if(isEventPending(%client.recentlyJoined) &&  !%client.isAdmin)
	{
		messageClient(%client, "","You must wait 30 seconds until you can rejoin the minigame.");
		return;
	}

	$DediMini.removeMember(%client);
	if(isobject(%client.player)) %client.player.kill();
	$DMMini.addMember(%client);

	if(isFile("Add-Ons/Event_Variables/server.cs"))
	{
		%client.oldBlockVCE[%client.BL_ID] = %client.blockVCE[%client.BL_ID];
		%client.blockVCE[%client.BL_ID] = true;
	}

	messageAll("", "\c6" @ "--------------------");
	messageAll("", "\c6" @ %client.netName SPC "\c4" @ "has joined the DM Arena!");
	messageAll("", "\c4" @ "Type" @ "\c6" SPC "/DM" SPC "\c4" @ "to join the DM Arena with" SPC "\c6" @ %client.netName @ "\c4" @ "!");
	messageAll("", "\c6" @ "--------------------");

	messageClient(%Client, "","\c4" @ "Type" @ "\c6" SPC "/DM" SPC "\c4" @ "to leave the Deathmatch!");
}

// +------------------------------------------------------------------------+
// | This is a special function made by Spaceguy to determine Brick Colors. |
// +------------------------------------------------------------------------+
function getClosestPaintColor(%rgba)
{
   %prevdist = 100000;
   %colorMatch = 0;
   for(%i = 0;%i < 64;%i++)
   {
      %color = getColorIDTable(%i);
      if(vectorDist(%rgba,getWords(%color,0,2)) < %prevdist && getWord(%rgba,3) - getWord(%color,3) < 0.3 && getWord(%rgba,3) - getWord(%color,3) > -0.3)
      {
         %prevdist = vectorDist(%rgba,%color);
         %colormatch = %i;
      }
   }
   return %colormatch;
}

// +---------------------------+
// | Event features by Destiny |
// +---------------------------+
if(isFile("Add-Ons/Event_Variables/server.cs"))
{
	registerOutputEvent(GameConnection, addBlocks, "string 32 100\tint 1 1000000 1", 0);

	registerOutputEvent(GameConnection, removeBlocks, "string 32 100\tint 1 1000000 1", 0);
}
else
{
	error("### Required Add-On Event_Variables is not enabled or not on the server!###"); 
}

// +---------------------------+
// | Event features by Destiny |
// +---------------------------+
function GameConnection::addBlocks(%client,%reason,%amount)
{
	%ownerid = getBrickGroupFromObject(%client.processingBrick).BL_ID;
	if(BL_IDisAutoAdmin(%ownerid) || BL_IDisAutoSuper(%ownerID))
		givePlayer(%client,%amount,%reason);
	else
		messageClient(%Client, "","Sorry, but this event can only be used by Auto-Admins!");
}

// +---------------------------+
// | Event features by Destiny |
// +---------------------------+
function GameConnection::removeBlocks(%client,%reason,%amount)
{
	%ownerid = getBrickGroupFromObject(%client.processingBrick).BL_ID;
	if(BL_IDisAutoAdmin(%ownerid) || BL_IDisAutoSuper(%ownerID))
		ChargePlayer(%client,%amount,%reason,1);
	else
		messageClient(%Client, "","Sorry, but this event can only be used by Auto-Admins!");
}

// +---------------------------+
// | Event features by Destiny |
// +---------------------------+
function BL_IDisAutoAdmin(%BLID)
{
	if(strPos(" "@$PREF::SERVER::AUTOADMINLIST@" "," "@%BLID@" ") >= 0)
		return true;
	return false;
}

// +---------------------------+
// | Event features by Destiny |
// +---------------------------+
function BL_IDisAutoSuper(%BLID)
{
	if(strPos(" "@$PREF::SERVER::AUTOSUPERADMINLIST@" "," "@%BLID@" ") >= 0)
		return true;
	return false;
}

function clearrecentlyJoined()
{
	//A null function.
}

function clearrecentBlocks()
{
	//A null function.
}


