// +=============================================+
// |  ____  _            _     ____ _ _          |
// | | __ )| | ___   ___| | __/ ___(_) |_ _   _  |
// | |  _ \| |/ _ \ / __| |/ / |   | | __| | | | |
// | | |_) | | (_) | (__|   <| |___| | |_| |_| | |
// | |____/|_|\___/ \___|_|\_\\____|_|\__|\__, | |
// |                                      |___/  |
// +=============================================+
// | This is the Currency Functions of the script|
// | Do not modify this file.			 |
// +---------------------------------------------+

// +-------------------------------------------+
// | This is an Admin-Only Feature.	       |
// | This gives the amount of Blocks to a user.|
// +-------------------------------------------+
function ServerCmdGrantBlocks(%client,%amnt,%target)
{
	if(!%client.isadmin) return;	//If the player is not an Admin, do nothing.
	if(%target $= "")
	{
		messageClient(%client, "", "Please enter all or part of a player's name (or BL_ID)");
		return;
	}
	if(!BCDB.ExistUser(%target)) //If the key exists (well it's most likley a BL_ID unless your not using BL_ID keys)
	{
		%target = findClientByName(%target);
		if(!isObject(%target))
		{
			messageClient(%client, "", "Player not found!");
			return;
		}
		%targetName = %target.netName;
		%targetID = %target.BL_ID;
	} else {
		%targetName = "BL_ID: "@%target@"";
		%targetID = %target;
	}
	if(currencyCheck(%amnt) == false)
	{
		messageClient(%client,"","Please enter a valid amount of blocks, (a non negative integer)");
		return;
	}
	BCDB.data[%targetID,"BLOCKS"] += %amnt;
	MessageAll("", "\c3" @ %targetName SPC "was granted\c2" SPC %amnt SPC "\c3Blocks by" SPC %client.netName @ "!");
	
	//Logging features.
	$BClog[$BClog[total]] = %client.netName SPC "has granted player" SPC %targetName @ ", " SPC %amnt SPC "Blocks. On" SPC getDateTime();	
	$BClog[total]++;
}
// +-------------------------------------------+
// | This is an Admin-Only Feature.	       |
// | This sets the amount of Blocks to a user. |
// +-------------------------------------------+
function ServerCmdsetBlocks(%client, %amnt, %target)
{
	if(!%client.isadmin) return;			//If the player is not an Admin, do nothing.

	if(%target $= "")
	{
		messageClient(%client, "", "Please enter all or part of a player's name (or BL_ID)");
		return;
	}
	if(!BCDB.ExistUser(%target)) //If the key exists (well it's most likley a BL_ID unless your not using BL_ID keys)
	{
		%target = findClientByName(%target);
		if(!isObject(%target))
		{
			messageClient(%client, "", "Player not found!");
			return;
		}
		%targetName = %target.netName;
		%targetID = %target.BL_ID;
	} else {
		%targetName = "BL_ID: "@%target@"";
		%targetID = %target;
	}
		
	if(currencyCheck(%amnt) == false)
	{
		messageClient(%client,"","Please enter a valid amount of blocks, (a non negative integer)");
		return;
	}

	BCDB.data[%targetID,"BLOCKS"] = %amnt;
	MessageAll("", "\c3" @ %targetName SPC "has had their Block amount set to" SPC %amnt SPC "Blocks by" SPC %client.netName @ "!");
	
	//Logging features.
	$BClog[$BClog[total]] = %client.netName SPC "has set player" SPC %targetName @ "'s Blocks to" SPC %amnt SPC "on" SPC getDateTime();	
	$BClog[total]++;
}

// +-----------------------------------------------+
// | This gives Blocks from one player to another. |
// +-----------------------------------------------+
function ServerCmdgiveBlocks(%client, %amnt, %target)
{

	if(isEventPending(%client.recentBlocks) &&  !%client.isAdmin)		//This sets a delay to prevent spam or lag on the server.
	{
		messageClient(%client, "","You must wait 30 seconds until you can try giving Blocks again.");
		return;
	}
	if(%target $= "")
	{
		messageClient(%client, "", "Please enter all or part of a player's name (or BL_ID)");
		return;
	}
	if(!BCDB.ExistUser(%target)) //If the key exists (well it's most likley a BL_ID unless your not using BL_ID keys)
	{
		%target = findClientByName(%target);
		if(!isObject(%target))
		{
			messageClient(%client, "", "Player not found!");
			return;
		}
		%targetName = %target.netName;
		%targetID = %target.BL_ID;
	} else {
		%targetName = "BL_ID: "@%target@"";
		%targetID = %target;
		%target = 0;
	}
	if(currencyCheck(%amnt) == false)
	{
		messageClient(%client,"","Please enter a valid amount of blocks, (a non negative integer)");
		return;
	}
	
	if(%Client.BL_ID == %TargetID)
	{
		messageClient(%client, "","You could give blocks to yourself, but that is just false excitment.");
		return;
	}
	if(BCDB.ExistUser(%client.BL_ID))				//If the player is in the database.
	{	
		if(BCDB.data[%client.BL_ID,"BLOCKS"] >= %amnt) // If the client has enough to give
		{
			BCDB.data[%client.BL_ID,"BLOCKS"] -= %amnt;
			BCDB.data[%TargetID,"BLOCKS"] += %amnt;

			messageClient(%client, "", "\c4" @ "You have given" @ "\c6" SPC  %amnt SPC "\c4" @ "Blocks to" SPC "\c6" @  %targetName @ "\c4.");
			if(isObject(%target)) messageClient(%target, "", "\c4" @ "You have been given" @ "\c6" SPC %amnt SPC "\c4" @ "Blocks from" SPC "\c6" @ %client.netName @ "\c4.");

			//Logging features.
			$BCLOG[$BCLOG[total]] = %client.netName SPC "gave blocks to" SPC %targetID SPC "on" SPC getDateTime();	
			$BCLOG[total]++;

			%client.recentBlocks = schedule(30000, 0, "clearrecentBlocks");
			return;
		}
		messageClient(%client, "","You do not have" SPC %amnt SPC "Blocks to give away!");

		%client.recentBlocks = schedule(30000, 0, "clearrecentBlocks");			

		return;
	}
	%client.recentBlocks = schedule(30000, 0, "clearrecentBlocks");


}

// +---------------------------------------------------------------------------+
// | This function checks to see how many Blocks a player has in the Database. |
// +---------------------------------------------------------------------------+
function ServerCmdPlayerBlocks(%client, %target)
{
	if(%target $= "")
		%target = %client.netName;
	if(!BCDB.ExistUser(%target)) //If the key exists (well it's most likley a BL_ID unless your not using BL_ID keys)
	{
		%target = findClientByName(%target);
		if(!isObject(%target))
		{
			messageClient(%client, "", "Player not found!");
			return;
		}
		%targetName = %target.netName;
		%targetID = %target.BL_ID;
	} else {
		%targetName = "BL_ID: "@%target@"";
		%targetID = %target;
	}
	messageClient(%client, "", "\c4" @ "Blockland User" @ "\c6" SPC %targetName SPC "\c4" @ "has" SPC "\c6" @ BCDB.data[%TargetID,"BLOCKS"] SPC "\c4" @ "Blocks.");
}
	
//------------------------------------------------------------------------------------------


// +----------------------------------------------------------------------------+
// | This function checks to make sure you have enough Blocks to plant a brick. |
// +----------------------------------------------------------------------------+
// DEPRECIATED (BlockCity 3-C) , use ChargePlayer() and GivePlayer() instead!
function checkBlocks(%client,%blockCost)
{
	warn("BlockCity: Call to depreciated function \"CheckBlocks()\"!");
	if(BCDB.data[%client.BL_ID,"BLOCKS"] >= %blockCost)
	{
		BCDB.data[%client.BL_ID,"BLOCKS"] -= %blockCost;
		brickMessage(%client,-%blockCost);
		return "OK";
	}
	messageClient(%client, 'MsgPlantError_Limit');
	%client.centerprint("<just:center>You do not have enough Blocks to plant this brick!" NL "Go mine or chop trees!", 2);
	return "NO";
}

// +-----------------------------------------+
// | Charges the player or denies the charge |
// +-----------------------------------------+
//  RETURNS : True if charged, False if not enough cash

// If the client is offline (you can only get an BL_ID) use these manually, using SimpleDB Methods and Variables.
function ChargePlayer(%client,%cost,%name,%quiet)
{
	if(%name $= "") %name = "brick";
	else %name = trim(%name);
	if(BCDB.data[%client.BL_ID,"BLOCKS"] < mFloor(mAbs(%cost)))
	{
		messageClient(%client, 'MsgPlantError_Limit');
		commandToClient(%client, 'centerPrint', "\c6You need \c0"@mFloor(mAbs(%cost))@"\c6 Blocks for a "@%name@", go mine or chop trees!",5);
		return false;
	}
	else
	{
		BCDB.data[%client.BL_ID,"BLOCKS"] -= mAbs(%cost);
		if(!%quiet) messageClient(%client,"","\c6Creating a \c3"@%name@"\c6 Cost you \c0"@mFloor(mAbs(%cost)));
		commandToClient(%client,'BottomPrint',"\c6You lost \c0"@mFloor(mAbs(%cost))@"\c6 Blocks.<just:right>Balance: \c2"@BCDB.data[%client.BL_ID,"BLOCKS"]@"\c6 Blocks!",5,3);
		return true;
	}
}
// +------------------------+
// | Gives the player money |
// +------------------------+
//  RETURNS : True if charged, False if not enough cash
function GivePlayer(%client,%amount,%name)
{
	%name=trim(%name);
	BCDB.data[%client.BL_ID,"BLOCKS"] += mFloor(mAbs(%amount));
	if(%name !$= "")
		commandToClient(%client,'BottomPrint',"\c6You gained \c2"@mFloor(mAbs(%amount))@"\c6 Blocks for \c2"@%name@"\c6.<just:right>Balance: \c2"@BCDB.data[%client.BL_ID,"BLOCKS"]@"\c6 Blocks!",5,3);
	else
		commandToClient(%client,'BottomPrint',"\c6You gained \c2"@mFloor(mAbs(%amount))@"\c6 Blocks.<just:right>Balance: \c2"@BCDB.data[%client.BL_ID,"BLOCKS"]@"\c6 Blocks!",5,3);
}